VTK: vtkProperty Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
vtkProperty Class Reference

represent surface properties of a geometric object More...

`#include <vtkProperty.h>`

Inheritance diagram for vtkProperty:
[legend]
Collaboration diagram for vtkProperty:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkProperty * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | DeepCopy (vtkProperty *p)
| Assign one property to another. More...
virtual void | Render (vtkActor *, vtkRenderer *)
| This method causes the property to set up whatever is required for its instance variables. More...
virtual void | BackfaceRender (vtkActor *, vtkRenderer *)
| This method renders the property as a backface property. More...
virtual void | PostRender (vtkActor *, vtkRenderer *)
| This method is called after the actor has been rendered. More...
void | SetBaseColorTexture (vtkTexture *texture)
| Set the base color texture. More...
void | SetORMTexture (vtkTexture *texture)
| Set the ORM texture. More...
void | SetAnisotropyTexture (vtkTexture *texture)
| Set the anisotropy texture. More...
void | SetNormalTexture (vtkTexture *texture)
| Set the normal texture. More...
void | SetEmissiveTexture (vtkTexture *texture)
| Set the emissive texture. More...
void | SetCoatNormalTexture (vtkTexture *texture)
| Set the coat normal texture. More...
void | RemoveTexture (const char *name)
| Remove a texture from the collection. More...
void | RemoveAllTextures ()
| Remove all the textures. More...
int | GetNumberOfTextures ()
| Returns the number of textures in this property. More...
std::map< std::string, vtkTexture * > & | GetAllTextures ()
| Returns all the textures in this property and their names. More...
virtual void | ReleaseGraphicsResources (vtkWindow *win)
| Release any graphics resources that are being consumed by this property. More...
virtual bool | GetLighting ()
| Set/Get lighting flag for an object. More...
virtual void | SetLighting (bool)
| Set/Get lighting flag for an object. More...
virtual void | LightingOn ()
| Set/Get lighting flag for an object. More...
virtual void | LightingOff ()
| Set/Get lighting flag for an object. More...
virtual bool | GetRenderPointsAsSpheres ()
| Set/Get rendering of points as spheres. More...
virtual void | SetRenderPointsAsSpheres (bool)
| Set/Get rendering of points as spheres. More...
virtual void | RenderPointsAsSpheresOn ()
| Set/Get rendering of points as spheres. More...
virtual void | RenderPointsAsSpheresOff ()
| Set/Get rendering of points as spheres. More...
virtual bool | GetRenderLinesAsTubes ()
| Set/Get rendering of lines as tubes. More...
virtual void | SetRenderLinesAsTubes (bool)
| Set/Get rendering of lines as tubes. More...
virtual void | RenderLinesAsTubesOn ()
| Set/Get rendering of lines as tubes. More...
virtual void | RenderLinesAsTubesOff ()
| Set/Get rendering of lines as tubes. More...
virtual void | SetInterpolation (int)
| Set the shading interpolation method for an object. More...
virtual int | GetInterpolation ()
| Set the shading interpolation method for an object. More...
void | SetInterpolationToFlat ()
| Set the shading interpolation method for an object. More...
void | SetInterpolationToGouraud ()
| Set the shading interpolation method for an object. More...
void | SetInterpolationToPhong ()
| Set the shading interpolation method for an object. More...
void | SetInterpolationToPBR ()
| Set the shading interpolation method for an object. More...
const char * | GetInterpolationAsString ()
| Return the method of shading as a descriptive character string. More...
virtual void | SetRepresentation (int)
| Control the surface geometry representation for the object. More...
virtual int | GetRepresentation ()
| Control the surface geometry representation for the object. More...
void | SetRepresentationToPoints ()
| Control the surface geometry representation for the object. More...
void | SetRepresentationToWireframe ()
| Control the surface geometry representation for the object. More...
void | SetRepresentationToSurface ()
| Control the surface geometry representation for the object. More...
const char * | GetRepresentationAsString ()
| Return the method of shading as a descriptive character string. More...
virtual void | SetColor (double r, double g, double b)
| Set the color of the object. More...
virtual void | SetColor (double a[3])
| Set the color of the object. More...
double * | GetColor ()
| Set the color of the object. More...
void | GetColor (double rgb[3])
| Set the color of the object. More...
void | GetColor (double &r, double &g, double &b)
| Set the color of the object. More...
virtual void | SetBaseIOR (double)
| Set/Get the Index Of Refraction of the base layer. More...
virtual double | GetBaseIOR ()
| Set/Get the Index Of Refraction of the base layer. More...
virtual void | SetMetallic (double)
| Set/Get the metallic coefficient. More...
virtual double | GetMetallic ()
| Set/Get the metallic coefficient. More...
virtual void | SetRoughness (double)
| Set/Get the roughness coefficient. More...
virtual double | GetRoughness ()
| Set/Get the roughness coefficient. More...
virtual void | SetAnisotropy (double)
| Set/Get the anisotropy coefficient. More...
virtual double | GetAnisotropy ()
| Set/Get the anisotropy coefficient. More...
virtual void | SetAnisotropyRotation (double)
| Set/Get the anisotropy rotation coefficient. More...
virtual double | GetAnisotropyRotation ()
| Set/Get the anisotropy rotation coefficient. More...
virtual void | SetCoatIOR (double)
| Set/Get the coat layer Index Of Refraction. More...
virtual double | GetCoatIOR ()
| Set/Get the coat layer Index Of Refraction. More...
virtual void | SetCoatRoughness (double)
| Set/Get the coat layer roughness coefficient. More...
virtual double | GetCoatRoughness ()
| Set/Get the coat layer roughness coefficient. More...
virtual void | SetCoatStrength (double)
| Set/Get the coat layer strength coefficient. More...
virtual double | GetCoatStrength ()
| Set/Get the coat layer strength coefficient. More...
virtual void | SetCoatColor (double, double, double)
| Set/Get the color of the coat layer. More...
virtual void | SetCoatColor (double[3])
| Set/Get the color of the coat layer. More...
virtual double * | GetCoatColor ()
| Set/Get the color of the coat layer. More...
virtual void | GetCoatColor (double &, double &, double &)
| Set/Get the color of the coat layer. More...
virtual void | GetCoatColor (double[3])
| Set/Get the color of the coat layer. More...
virtual void | SetCoatNormalScale (double)
| Set/Get the coat layer normal scale coefficient. More...
virtual double | GetCoatNormalScale ()
| Set/Get the coat layer normal scale coefficient. More...
virtual void | SetNormalScale (double)
| Set/Get the normal scale coefficient. More...
virtual double | GetNormalScale ()
| Set/Get the normal scale coefficient. More...
virtual void | SetOcclusionStrength (double)
| Set/Get the occlusion strength coefficient. More...
virtual double | GetOcclusionStrength ()
| Set/Get the occlusion strength coefficient. More...
virtual void | SetEmissiveFactor (double, double, double)
| Set/Get the emissive factor. More...
virtual void | SetEmissiveFactor (double[3])
| Set/Get the emissive factor. More...
virtual double * | GetEmissiveFactor ()
| Set/Get the emissive factor. More...
virtual void | GetEmissiveFactor (double &, double &, double &)
| Set/Get the emissive factor. More...
virtual void | GetEmissiveFactor (double[3])
| Set/Get the emissive factor. More...
virtual void | SetEdgeTint (double, double, double)
| Set/Get the edge tint (for metals only). More...
virtual void | SetEdgeTint (double[3])
| Set/Get the edge tint (for metals only). More...
virtual double * | GetEdgeTint ()
| Set/Get the edge tint (for metals only). More...
virtual void | GetEdgeTint (double &, double &, double &)
| Set/Get the edge tint (for metals only). More...
virtual void | GetEdgeTint (double[3])
| Set/Get the edge tint (for metals only). More...
virtual void | SetAmbient (double)
| Set/Get the ambient lighting coefficient. More...
virtual double | GetAmbient ()
| Set/Get the ambient lighting coefficient. More...
virtual void | SetDiffuse (double)
| Set/Get the diffuse lighting coefficient. More...
virtual double | GetDiffuse ()
| Set/Get the diffuse lighting coefficient. More...
virtual void | SetSpecular (double)
| Set/Get the specular lighting coefficient. More...
virtual double | GetSpecular ()
| Set/Get the specular lighting coefficient. More...
virtual void | SetSpecularPower (double)
| Set/Get the specular power. More...
virtual double | GetSpecularPower ()
| Set/Get the specular power. More...
virtual void | SetOpacity (double)
| Set/Get the object's opacity. More...
virtual double | GetOpacity ()
| Set/Get the object's opacity. More...
virtual void | SetEdgeOpacity (double)
| Set/Get the line opacity. More...
virtual double | GetEdgeOpacity ()
| Set/Get the line opacity. More...
virtual void | SetAmbientColor (double, double, double)
| Set/Get the ambient surface color. More...
virtual void | SetAmbientColor (double[3])
| Set/Get the ambient surface color. More...
virtual double * | GetAmbientColor ()
| Set/Get the ambient surface color. More...
virtual void | GetAmbientColor (double &, double &, double &)
| Set/Get the ambient surface color. More...
virtual void | GetAmbientColor (double[3])
| Set/Get the ambient surface color. More...
virtual void | SetDiffuseColor (double, double, double)
| Set/Get the diffuse surface color. More...
virtual void | SetDiffuseColor (double[3])
| Set/Get the diffuse surface color. More...
virtual double * | GetDiffuseColor ()
| Set/Get the diffuse surface color. More...
virtual void | GetDiffuseColor (double &, double &, double &)
| Set/Get the diffuse surface color. More...
virtual void | GetDiffuseColor (double[3])
| Set/Get the diffuse surface color. More...
virtual void | SetSpecularColor (double, double, double)
| Set/Get the specular surface color. More...
virtual void | SetSpecularColor (double[3])
| Set/Get the specular surface color. More...
virtual double * | GetSpecularColor ()
| Set/Get the specular surface color. More...
virtual void | GetSpecularColor (double &, double &, double &)
| Set/Get the specular surface color. More...
virtual void | GetSpecularColor (double[3])
| Set/Get the specular surface color. More...
virtual vtkTypeBool | GetEdgeVisibility ()
| Turn on/off the visibility of edges. More...
virtual void | SetEdgeVisibility (vtkTypeBool)
| Turn on/off the visibility of edges. More...
virtual void | EdgeVisibilityOn ()
| Turn on/off the visibility of edges. More...
virtual void | EdgeVisibilityOff ()
| Turn on/off the visibility of edges. More...
virtual void | SetEdgeColor (double, double, double)
| Set/Get the color of primitive edges (if edge visibility is enabled). More...
virtual void | SetEdgeColor (double[3])
| Set/Get the color of primitive edges (if edge visibility is enabled). More...
virtual double * | GetEdgeColor ()
| Set/Get the color of primitive edges (if edge visibility is enabled). More...
virtual void | GetEdgeColor (double &, double &, double &)
| Set/Get the color of primitive edges (if edge visibility is enabled). More...
virtual void | GetEdgeColor (double[3])
| Set/Get the color of primitive edges (if edge visibility is enabled). More...
virtual vtkTypeBool | GetVertexVisibility ()
| Turn on/off the visibility of vertices. More...
virtual void | SetVertexVisibility (vtkTypeBool)
| Turn on/off the visibility of vertices. More...
virtual void | VertexVisibilityOn ()
| Turn on/off the visibility of vertices. More...
virtual void | VertexVisibilityOff ()
| Turn on/off the visibility of vertices. More...
virtual void | SetVertexColor (double, double, double)
| Set/Get the color of primitive vertices (if vertex visibility is enabled). More...
virtual void | SetVertexColor (double[3])
| Set/Get the color of primitive vertices (if vertex visibility is enabled). More...
virtual double * | GetVertexColor ()
| Set/Get the color of primitive vertices (if vertex visibility is enabled). More...
virtual void | GetVertexColor (double &, double &, double &)
| Set/Get the color of primitive vertices (if vertex visibility is enabled). More...
virtual void | GetVertexColor (double[3])
| Set/Get the color of primitive vertices (if vertex visibility is enabled). More...
virtual void | SetSelectionColor (double, double, double, double)
| Set/Get the RGBA color of selection primitives (if a selection is active on the mapper). More...
virtual void | SetSelectionColor (double[4])
| Set/Get the RGBA color of selection primitives (if a selection is active on the mapper). More...
virtual double * | GetSelectionColor ()
| Set/Get the RGBA color of selection primitives (if a selection is active on the mapper). More...
virtual void | GetSelectionColor (double &, double &, double &, double &)
| Set/Get the RGBA color of selection primitives (if a selection is active on the mapper). More...
virtual void | GetSelectionColor (double[4])
| Set/Get the RGBA color of selection primitives (if a selection is active on the mapper). More...
virtual void | SetSelectionLineWidth (float)
| Set/Get the selection line width. More...
virtual float | GetSelectionLineWidth ()
| Set/Get the selection line width. More...
virtual void | SetSelectionPointSize (float)
| Set/Get the selection point size. More...
virtual float | GetSelectionPointSize ()
| Set/Get the selection point size. More...
virtual void | SetLineWidth (float)
| Set/Get the width of a Line. More...
virtual float | GetLineWidth ()
| Set/Get the width of a Line. More...
virtual void | SetLineStipplePattern (int)
| Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off). More...
virtual int | GetLineStipplePattern ()
| Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off). More...
virtual void | SetLineStippleRepeatFactor (int)
| Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated. More...
virtual int | GetLineStippleRepeatFactor ()
| Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated. More...
virtual void | SetPointSize (float)
| Set/Get the diameter of a point. More...
virtual float | GetPointSize ()
| Set/Get the diameter of a point. More...
virtual vtkTypeBool | GetBackfaceCulling ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | SetBackfaceCulling (vtkTypeBool)
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | BackfaceCullingOn ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | BackfaceCullingOff ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual vtkTypeBool | GetFrontfaceCulling ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | SetFrontfaceCulling (vtkTypeBool)
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | FrontfaceCullingOn ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | FrontfaceCullingOff ()
| Turn on/off fast culling of polygons based on orientation of normal with respect to camera. More...
virtual void | SetMaterialName (const char *)
| Returns the name of the material currently loaded, if any. More...
virtual char * | GetMaterialName ()
| Returns the name of the material currently loaded, if any. More...
virtual void | SetShading (vtkTypeBool)
| Enable/Disable shading. More...
virtual vtkTypeBool | GetShading ()
| Enable/Disable shading. More...
virtual void | ShadingOn ()
| Enable/Disable shading. More...
virtual void | ShadingOff ()
| Enable/Disable shading. More...
virtual void | AddShaderVariable (const char *name, int numVars, int *x)
| Provide values to initialize shader variables. More...
virtual void | AddShaderVariable (const char *name, int numVars, float *x)
| Provide values to initialize shader variables. More...
virtual void | AddShaderVariable (const char *name, int numVars, double *x)
| Provide values to initialize shader variables. More...
void | AddShaderVariable (const char *name, int v)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, float v)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, double v)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, int v1, int v2)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, float v1, float v2)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, double v1, double v2)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, int v1, int v2, int v3)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, float v1, float v2, float v3)
| Methods to provide to add shader variables from wrappers. More...
void | AddShaderVariable (const char *name, double v1, double v2, double v3)
| Methods to provide to add shader variables from wrappers. More...
virtual void | SetShowTexturesOnBackface (bool)
| Show texture maps when the geometry is backfacing. More...
virtual bool | GetShowTexturesOnBackface ()
| Show texture maps when the geometry is backfacing. More...
virtual void | ShowTexturesOnBackfaceOn ()
| Show texture maps when the geometry is backfacing. More...
virtual void | ShowTexturesOnBackfaceOff ()
| Show texture maps when the geometry is backfacing. More...
void | SetTexture (const char *name, vtkTexture *texture)
| Set/Get the texture object to control rendering texture maps. More...
vtkTexture * | GetTexture (const char *name)
| Set/Get the texture object to control rendering texture maps. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with the Property. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with the Property. More...
double | ComputeReflectanceOfBaseLayer ()
| For PBR, calculate the reflectance of the base layer depending on the presence of a coat layer. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkProperty * | SafeDownCast (vtkObjectBase *o)
static vtkProperty * | New ()
| Construct object with object color, ambient color, diffuse color, specular color, and edge color white; ambient coefficient=0; diffuse coefficient=0; specular coefficient=0; specular power=1; Gouraud shading; and surface representation. More...
static double | ComputeReflectanceFromIOR (double IORTo, double IORFrom)
| For PBR, calculate the reflectance from the refractive index of ingoing and outgoing interfaces. More...
static double | ComputeIORFromReflectance (double reflectance, double ior)
| For PBR, calculate the refractive index from the reflectance of the interface and the refractive index of one of both medium. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Types
typedef std::map< std::string, vtkTexture * > | MapOfTextures

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkProperty ()
| ~vtkProperty () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions
static void | ComputeCompositeColor (double result[3], double ambient, const double ambient_color[3], double diffuse, const double diffuse_color[3], double specular, const double specular_color[3])
| Computes composite color. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Protected Attributes
double | Color [3]
double | AmbientColor [3]
double | DiffuseColor [3]
double | SpecularColor [3]
double | EdgeColor [3]
double | VertexColor [3]
double | SelectionColor [4] = { 1.0, 0.0, 0.0, 1.0 }
double | Ambient
double | Diffuse
double | Metallic
double | Roughness
double | Anisotropy
double | AnisotropyRotation
double | BaseIOR
double | CoatIOR
double | CoatColor [3]
double | CoatRoughness
double | CoatStrength
double | CoatNormalScale
double | NormalScale
double | OcclusionStrength
double | EmissiveFactor [3]
double | Specular
double | SpecularPower
double | Opacity
double | EdgeOpacity = 1.0
double | EdgeTint [3]
float | PointSize
float | LineWidth
float | SelectionPointSize = 2.f
float | SelectionLineWidth = 2.f
int | LineStipplePattern
int | LineStippleRepeatFactor
int | Interpolation
int | Representation
vtkTypeBool | EdgeVisibility
vtkTypeBool | VertexVisibility
vtkTypeBool | BackfaceCulling
vtkTypeBool | FrontfaceCulling
bool | Lighting
bool | RenderPointsAsSpheres
bool | RenderLinesAsTubes
bool | ShowTexturesOnBackface
vtkTypeBool | Shading
char * | MaterialName
MapOfTextures | Textures
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

represent surface properties of a geometric object

vtkProperty is an object that represents lighting and other surface properties of a geometric object. The primary properties that can be set are colors (overall, ambient, diffuse, specular, and edge color); specular power; opacity of the object; the representation of the object (points, wireframe, or surface); and the shading method to be used (flat, Gouraud, and Phong). Also, some special graphics features like backface properties can be set and manipulated with this object.

See also
  vtkActor vtkPropertyDevice

Examples:
  vtkProperty (Examples)

Online Examples:

Tests:
  vtkProperty (Tests)

Definition at line 65 of file vtkProperty.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkProperty::Superclass

Definition at line 68 of file vtkProperty.h.

## ◆ MapOfTextures

typedef std::map<std::string, vtkTexture*> vtkProperty::MapOfTextures
| protected

Definition at line 818 of file vtkProperty.h.

## Constructor & Destructor Documentation

## ◆ vtkProperty()

vtkProperty::vtkProperty | ( |  | ) |
| protected

## ◆ ~vtkProperty()

vtkProperty::~vtkProperty | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkProperty::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkProperty::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkWebGPUProperty, vtkOpenGLProperty, and vtkRIBProperty.

## ◆ SafeDownCast()

static vtkProperty* vtkProperty::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkProperty::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkWebGPUProperty, vtkOpenGLProperty, and vtkRIBProperty.

## ◆ NewInstance()

vtkProperty* vtkProperty::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkProperty::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkWebGPUProperty, and vtkOpenGLProperty.

## ◆ New()

static vtkProperty* vtkProperty::New | ( |  | ) |
| static

Construct object with object color, ambient color, diffuse color, specular color, and edge color white; ambient coefficient=0; diffuse coefficient=0; specular coefficient=0; specular power=1; Gouraud shading; and surface representation.

Backface and frontface culling are off.

## ◆ DeepCopy()

void vtkProperty::DeepCopy | ( | vtkProperty * | p | ) |

Assign one property to another.

## ◆ Render()

virtual void vtkProperty::Render | ( | vtkActor * | ,
|  | vtkRenderer * |
| ) |  |
| virtual

This method causes the property to set up whatever is required for its instance variables.

This is actually handled by a subclass of vtkProperty, which is created automatically. This method includes the invoking actor as an argument which can be used by property devices that require the actor.

Reimplemented in vtkWebGPUProperty, vtkOpenGLProperty, and vtkRIBProperty.

## ◆ BackfaceRender()

virtual void vtkProperty::BackfaceRender | ( | vtkActor * | ,
|  | vtkRenderer * |
| ) |  |
| inlinevirtual

This method renders the property as a backface property.

TwoSidedLighting must be turned off to see any backface properties. Note that only colors and opacity are used for backface properties. Other properties such as Representation, Culling are specified by the Property.

Reimplemented in vtkWebGPUProperty, and vtkOpenGLProperty.

Definition at line 99 of file vtkProperty.h.

## ◆ PostRender()

virtual void vtkProperty::PostRender | ( | vtkActor * | ,
|  | vtkRenderer * |
| ) |  |
| virtual

This method is called after the actor has been rendered.

Don't call this directly. This method cleans up any shaders allocated.

Reimplemented in vtkWebGPUProperty, and vtkOpenGLProperty.

## ◆ GetLighting()

virtual bool vtkProperty::GetLighting | ( |  | ) |
| virtual

Set/Get lighting flag for an object.

Initial value is true.

## ◆ SetLighting()

virtual void vtkProperty::SetLighting | ( | bool |  | ) |
| virtual

Set/Get lighting flag for an object.

Initial value is true.

## ◆ LightingOn()

virtual void vtkProperty::LightingOn | ( |  | ) |
| virtual

Set/Get lighting flag for an object.

Initial value is true.

## ◆ LightingOff()

virtual void vtkProperty::LightingOff | ( |  | ) |
| virtual

Set/Get lighting flag for an object.

Initial value is true.

## ◆ GetRenderPointsAsSpheres()

virtual bool vtkProperty::GetRenderPointsAsSpheres | ( |  | ) |
| virtual

Set/Get rendering of points as spheres.

The size of the sphere in pixels is controlled by the PointSize attribute. Note that half spheres may be rendered instead of spheres.

## ◆ SetRenderPointsAsSpheres()

virtual void vtkProperty::SetRenderPointsAsSpheres | ( | bool |  | ) |
| virtual

Set/Get rendering of points as spheres.

The size of the sphere in pixels is controlled by the PointSize attribute. Note that half spheres may be rendered instead of spheres.

## ◆ RenderPointsAsSpheresOn()

virtual void vtkProperty::RenderPointsAsSpheresOn | ( |  | ) |
| virtual

Set/Get rendering of points as spheres.

The size of the sphere in pixels is controlled by the PointSize attribute. Note that half spheres may be rendered instead of spheres.

## ◆ RenderPointsAsSpheresOff()

virtual void vtkProperty::RenderPointsAsSpheresOff | ( |  | ) |
| virtual

Set/Get rendering of points as spheres.

The size of the sphere in pixels is controlled by the PointSize attribute. Note that half spheres may be rendered instead of spheres.

## ◆ GetRenderLinesAsTubes()

virtual bool vtkProperty::GetRenderLinesAsTubes | ( |  | ) |
| virtual

Set/Get rendering of lines as tubes.

The width of the line in pixels is controlled by the LineWidth attribute. May not be supported on every platform and the implementation may be half tubes, or something only tube like in appearance.

## ◆ SetRenderLinesAsTubes()

virtual void vtkProperty::SetRenderLinesAsTubes | ( | bool |  | ) |
| virtual

Set/Get rendering of lines as tubes.

The width of the line in pixels is controlled by the LineWidth attribute. May not be supported on every platform and the implementation may be half tubes, or something only tube like in appearance.

## ◆ RenderLinesAsTubesOn()

virtual void vtkProperty::RenderLinesAsTubesOn | ( |  | ) |
| virtual

Set/Get rendering of lines as tubes.

The width of the line in pixels is controlled by the LineWidth attribute. May not be supported on every platform and the implementation may be half tubes, or something only tube like in appearance.

## ◆ RenderLinesAsTubesOff()

virtual void vtkProperty::RenderLinesAsTubesOff | ( |  | ) |
| virtual

Set/Get rendering of lines as tubes.

The width of the line in pixels is controlled by the LineWidth attribute. May not be supported on every platform and the implementation may be half tubes, or something only tube like in appearance.

## ◆ SetInterpolation()

virtual void vtkProperty::SetInterpolation | ( | int |  | ) |
| virtual

Set the shading interpolation method for an object.

## ◆ GetInterpolation()

virtual int vtkProperty::GetInterpolation | ( |  | ) |
| virtual

Set the shading interpolation method for an object.

## ◆ SetInterpolationToFlat()

void vtkProperty::SetInterpolationToFlat | ( |  | ) |
| inline

Set the shading interpolation method for an object.

Definition at line 148 of file vtkProperty.h.

## ◆ SetInterpolationToGouraud()

void vtkProperty::SetInterpolationToGouraud | ( |  | ) |
| inline

Set the shading interpolation method for an object.

Definition at line 149 of file vtkProperty.h.

## ◆ SetInterpolationToPhong()

void vtkProperty::SetInterpolationToPhong | ( |  | ) |
| inline

Set the shading interpolation method for an object.

Definition at line 150 of file vtkProperty.h.

## ◆ SetInterpolationToPBR()

void vtkProperty::SetInterpolationToPBR | ( |  | ) |
| inline

Set the shading interpolation method for an object.

Definition at line 151 of file vtkProperty.h.

## ◆ GetInterpolationAsString()

const char * vtkProperty::GetInterpolationAsString | ( |  | ) |
| inline

Return the method of shading as a descriptive character string.

Definition at line 832 of file vtkProperty.h.

## ◆ SetRepresentation()

virtual void vtkProperty::SetRepresentation | ( | int |  | ) |
| virtual

Control the surface geometry representation for the object.

## ◆ GetRepresentation()

virtual int vtkProperty::GetRepresentation | ( |  | ) |
| virtual

Control the surface geometry representation for the object.

## ◆ SetRepresentationToPoints()

void vtkProperty::SetRepresentationToPoints | ( |  | ) |
| inline

Control the surface geometry representation for the object.

Definition at line 161 of file vtkProperty.h.

## ◆ SetRepresentationToWireframe()

void vtkProperty::SetRepresentationToWireframe | ( |  | ) |
| inline

Control the surface geometry representation for the object.

Definition at line 162 of file vtkProperty.h.

## ◆ SetRepresentationToSurface()

void vtkProperty::SetRepresentationToSurface | ( |  | ) |
| inline

Control the surface geometry representation for the object.

Definition at line 163 of file vtkProperty.h.

## ◆ GetRepresentationAsString()

const char * vtkProperty::GetRepresentationAsString | ( |  | ) |
| inline

Return the method of shading as a descriptive character string.

Definition at line 855 of file vtkProperty.h.

## ◆ SetColor() [1/2]

virtual void vtkProperty::SetColor | ( | double | r,
|  | double | g,
|  | double | b
| ) |  |
| virtual

Set the color of the object.

Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

## ◆ SetColor() [2/2]

virtual void vtkProperty::SetColor | ( | double | a[3] | ) |
| virtual

Set the color of the object.

Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

## ◆ GetColor() [1/3]

double* vtkProperty::GetColor | ( |  | ) |

Set the color of the object.

Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

## ◆ GetColor() [2/3]

void vtkProperty::GetColor | ( | double | rgb[3] | ) |

Set the color of the object.

Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

## ◆ GetColor() [3/3]

void vtkProperty::GetColor | ( | double & | r,
|  | double & | g,
|  | double & | b
| ) |  |

Set the color of the object.

Has the side effect of setting the ambient diffuse and specular colors as well. This is basically a quick overall color setting method.

## ◆ SetBaseIOR()

virtual void vtkProperty::SetBaseIOR | ( | double |  | ) |
| virtual

Set/Get the Index Of Refraction of the base layer.

It controls the amount of light reflected at normal incidence (the reflectance F0), depending on the IOR of the upper layer (eg. coat layer, or environment). For example, with a base IOR of 1.5 and an IOR of 1.0 outside (IOR of the air), 4% of the amount of the light is reflected at normal incidence. Notice that modifying this value is only useful for dielectrics materials, as the reflectance for metallic is the albedo. This parameter is only used by PBR Interpolation. Default value is 1.5

## ◆ GetBaseIOR()

virtual double vtkProperty::GetBaseIOR | ( |  | ) |
| virtual

Set/Get the Index Of Refraction of the base layer.

It controls the amount of light reflected at normal incidence (the reflectance F0), depending on the IOR of the upper layer (eg. coat layer, or environment). For example, with a base IOR of 1.5 and an IOR of 1.0 outside (IOR of the air), 4% of the amount of the light is reflected at normal incidence. Notice that modifying this value is only useful for dielectrics materials, as the reflectance for metallic is the albedo. This parameter is only used by PBR Interpolation. Default value is 1.5

## ◆ SetMetallic()

virtual void vtkProperty::SetMetallic | ( | double |  | ) |
| virtual

Set/Get the metallic coefficient.

Usually this value is either 0 or 1 for real material but any value in between is valid. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ GetMetallic()

virtual double vtkProperty::GetMetallic | ( |  | ) |
| virtual

Set/Get the metallic coefficient.

Usually this value is either 0 or 1 for real material but any value in between is valid. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ SetRoughness()

virtual void vtkProperty::SetRoughness | ( | double |  | ) |
| virtual

Set/Get the roughness coefficient.

This value has to be between 0 (glossy) and 1 (rough). A glossy material has reflections and a high specular part. This parameter is only used by PBR Interpolation. Default value is 0.5

## ◆ GetRoughness()

virtual double vtkProperty::GetRoughness | ( |  | ) |
| virtual

Set/Get the roughness coefficient.

This value has to be between 0 (glossy) and 1 (rough). A glossy material has reflections and a high specular part. This parameter is only used by PBR Interpolation. Default value is 0.5

## ◆ SetAnisotropy()

virtual void vtkProperty::SetAnisotropy | ( | double |  | ) |
| virtual

Set/Get the anisotropy coefficient.

This value controls the anisotropy of the material (0.0 means isotropic) This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ GetAnisotropy()

virtual double vtkProperty::GetAnisotropy | ( |  | ) |
| virtual

Set/Get the anisotropy coefficient.

This value controls the anisotropy of the material (0.0 means isotropic) This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ SetAnisotropyRotation()

virtual void vtkProperty::SetAnisotropyRotation | ( | double |  | ) |
| virtual

Set/Get the anisotropy rotation coefficient.

This value controls the rotation of the direction of the anisotropy. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ GetAnisotropyRotation()

virtual double vtkProperty::GetAnisotropyRotation | ( |  | ) |
| virtual

Set/Get the anisotropy rotation coefficient.

This value controls the rotation of the direction of the anisotropy. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ SetCoatIOR()

virtual void vtkProperty::SetCoatIOR | ( | double |  | ) |
| virtual

Set/Get the coat layer Index Of Refraction.

This parameter is only used by PBR Interpolation. Default value is 2.0

## ◆ GetCoatIOR()

virtual double vtkProperty::GetCoatIOR | ( |  | ) |
| virtual

Set/Get the coat layer Index Of Refraction.

This parameter is only used by PBR Interpolation. Default value is 2.0

## ◆ SetCoatRoughness()

virtual void vtkProperty::SetCoatRoughness | ( | double |  | ) |
| virtual

Set/Get the coat layer roughness coefficient.

This value has to be between 0 (glossy) and 1 (rough). This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ GetCoatRoughness()

virtual double vtkProperty::GetCoatRoughness | ( |  | ) |
| virtual

Set/Get the coat layer roughness coefficient.

This value has to be between 0 (glossy) and 1 (rough). This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ SetCoatStrength()

virtual void vtkProperty::SetCoatStrength | ( | double |  | ) |
| virtual

Set/Get the coat layer strength coefficient.

This value affects the strength of the coat layer reflection. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ GetCoatStrength()

virtual double vtkProperty::GetCoatStrength | ( |  | ) |
| virtual

Set/Get the coat layer strength coefficient.

This value affects the strength of the coat layer reflection. This parameter is only used by PBR Interpolation. Default value is 0.0

## ◆ SetCoatColor() [1/2]

virtual void vtkProperty::SetCoatColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of the coat layer.

This value is only used by PBR Interpolation. Default value is white [1.0, 1.0, 1.0]

## ◆ SetCoatColor() [2/2]

virtual void vtkProperty::SetCoatColor | ( | double | [3] | ) |
| virtual

Set/Get the color of the coat layer.

This value is only used by PBR Interpolation. Default value is white [1.0, 1.0, 1.0]

## ◆ GetCoatColor() [1/3]

virtual double* vtkProperty::GetCoatColor | ( |  | ) |
| virtual

Set/Get the color of the coat layer.

This value is only used by PBR Interpolation. Default value is white [1.0, 1.0, 1.0]

## ◆ GetCoatColor() [2/3]

virtual void vtkProperty::GetCoatColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the color of the coat layer.

This value is only used by PBR Interpolation. Default value is white [1.0, 1.0, 1.0]

## ◆ GetCoatColor() [3/3]

virtual void vtkProperty::GetCoatColor | ( | double | [3] | ) |
| virtual

Set/Get the color of the coat layer.

This value is only used by PBR Interpolation. Default value is white [1.0, 1.0, 1.0]

## ◆ SetCoatNormalScale()

virtual void vtkProperty::SetCoatNormalScale | ( | double |  | ) |
| virtual

Set/Get the coat layer normal scale coefficient.

This value affects the strength of the normal deviation from the coat normal texture. This parameter is only used by PBR Interpolation. Default value is 1.0

## ◆ GetCoatNormalScale()

virtual double vtkProperty::GetCoatNormalScale | ( |  | ) |
| virtual

Set/Get the coat layer normal scale coefficient.

This value affects the strength of the normal deviation from the coat normal texture. This parameter is only used by PBR Interpolation. Default value is 1.0

## ◆ SetNormalScale()

virtual void vtkProperty::SetNormalScale | ( | double |  | ) |
| virtual

Set/Get the normal scale coefficient.

This value affects the strength of the normal deviation from the texture. Default value is 1.0

## ◆ GetNormalScale()

virtual double vtkProperty::GetNormalScale | ( |  | ) |
| virtual

Set/Get the normal scale coefficient.

This value affects the strength of the normal deviation from the texture. Default value is 1.0

## ◆ SetOcclusionStrength()

virtual void vtkProperty::SetOcclusionStrength | ( | double |  | ) |
| virtual

Set/Get the occlusion strength coefficient.

This value affects the strength of the occlusion if a material texture is present. This parameter is only used by PBR Interpolation. Default value is 1.0

## ◆ GetOcclusionStrength()

virtual double vtkProperty::GetOcclusionStrength | ( |  | ) |
| virtual

Set/Get the occlusion strength coefficient.

This value affects the strength of the occlusion if a material texture is present. This parameter is only used by PBR Interpolation. Default value is 1.0

## ◆ SetEmissiveFactor() [1/2]

virtual void vtkProperty::SetEmissiveFactor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the emissive factor.

This value is multiplied with the emissive color when an emissive texture is present. This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ SetEmissiveFactor() [2/2]

virtual void vtkProperty::SetEmissiveFactor | ( | double | [3] | ) |
| virtual

Set/Get the emissive factor.

This value is multiplied with the emissive color when an emissive texture is present. This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEmissiveFactor() [1/3]

virtual double* vtkProperty::GetEmissiveFactor | ( |  | ) |
| virtual

Set/Get the emissive factor.

This value is multiplied with the emissive color when an emissive texture is present. This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEmissiveFactor() [2/3]

virtual void vtkProperty::GetEmissiveFactor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the emissive factor.

This value is multiplied with the emissive color when an emissive texture is present. This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEmissiveFactor() [3/3]

virtual void vtkProperty::GetEmissiveFactor | ( | double | [3] | ) |
| virtual

Set/Get the emissive factor.

This value is multiplied with the emissive color when an emissive texture is present. This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ SetEdgeTint() [1/2]

virtual void vtkProperty::SetEdgeTint | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the edge tint (for metals only).

Set the color at grazing angle (fresnel reflectance). This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ SetEdgeTint() [2/2]

virtual void vtkProperty::SetEdgeTint | ( | double | [3] | ) |
| virtual

Set/Get the edge tint (for metals only).

Set the color at grazing angle (fresnel reflectance). This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEdgeTint() [1/3]

virtual double* vtkProperty::GetEdgeTint | ( |  | ) |
| virtual

Set/Get the edge tint (for metals only).

Set the color at grazing angle (fresnel reflectance). This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEdgeTint() [2/3]

virtual void vtkProperty::GetEdgeTint | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the edge tint (for metals only).

Set the color at grazing angle (fresnel reflectance). This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ GetEdgeTint() [3/3]

virtual void vtkProperty::GetEdgeTint | ( | double | [3] | ) |
| virtual

Set/Get the edge tint (for metals only).

Set the color at grazing angle (fresnel reflectance). This parameter is only used by PBR Interpolation. Default value is [1.0, 1.0, 1.0]

## ◆ SetAmbient()

virtual void vtkProperty::SetAmbient | ( | double |  | ) |
| virtual

Set/Get the ambient lighting coefficient.

## ◆ GetAmbient()

virtual double vtkProperty::GetAmbient | ( |  | ) |
| virtual

Set/Get the ambient lighting coefficient.

## ◆ SetDiffuse()

virtual void vtkProperty::SetDiffuse | ( | double |  | ) |
| virtual

Set/Get the diffuse lighting coefficient.

## ◆ GetDiffuse()

virtual double vtkProperty::GetDiffuse | ( |  | ) |
| virtual

Set/Get the diffuse lighting coefficient.

## ◆ SetSpecular()

virtual void vtkProperty::SetSpecular | ( | double |  | ) |
| virtual

Set/Get the specular lighting coefficient.

## ◆ GetSpecular()

virtual double vtkProperty::GetSpecular | ( |  | ) |
| virtual

Set/Get the specular lighting coefficient.

## ◆ SetSpecularPower()

virtual void vtkProperty::SetSpecularPower | ( | double |  | ) |
| virtual

Set/Get the specular power.

## ◆ GetSpecularPower()

virtual double vtkProperty::GetSpecularPower | ( |  | ) |
| virtual

Set/Get the specular power.

## ◆ SetOpacity()

virtual void vtkProperty::SetOpacity | ( | double |  | ) |
| virtual

Set/Get the object's opacity.

1.0 is totally opaque and 0.0 is completely transparent.

## ◆ GetOpacity()

virtual double vtkProperty::GetOpacity | ( |  | ) |
| virtual

Set/Get the object's opacity.

1.0 is totally opaque and 0.0 is completely transparent.

## ◆ SetEdgeOpacity()

virtual void vtkProperty::SetEdgeOpacity | ( | double |  | ) |
| virtual

Set/Get the line opacity.

1.0 is totally opaque and 0.0 is completely transparent.

## ◆ GetEdgeOpacity()

virtual double vtkProperty::GetEdgeOpacity | ( |  | ) |
| virtual

Set/Get the line opacity.

1.0 is totally opaque and 0.0 is completely transparent.

## ◆ SetAmbientColor() [1/2]

virtual void vtkProperty::SetAmbientColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the ambient surface color.

Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

## ◆ SetAmbientColor() [2/2]

virtual void vtkProperty::SetAmbientColor | ( | double | [3] | ) |
| virtual

Set/Get the ambient surface color.

Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

## ◆ GetAmbientColor() [1/3]

virtual double* vtkProperty::GetAmbientColor | ( |  | ) |
| virtual

Set/Get the ambient surface color.

Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

## ◆ GetAmbientColor() [2/3]

virtual void vtkProperty::GetAmbientColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the ambient surface color.

Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

## ◆ GetAmbientColor() [3/3]

virtual void vtkProperty::GetAmbientColor | ( | double | [3] | ) |
| virtual

Set/Get the ambient surface color.

Not all renderers support separate ambient and diffuse colors. From a physical standpoint it really doesn't make too much sense to have both. For the rendering libraries that don't support both, the diffuse color is used.

## ◆ SetDiffuseColor() [1/2]

virtual void vtkProperty::SetDiffuseColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the diffuse surface color.

For PBR Interpolation, DiffuseColor is used as the base color

## ◆ SetDiffuseColor() [2/2]

virtual void vtkProperty::SetDiffuseColor | ( | double | [3] | ) |
| virtual

Set/Get the diffuse surface color.

For PBR Interpolation, DiffuseColor is used as the base color

## ◆ GetDiffuseColor() [1/3]

virtual double* vtkProperty::GetDiffuseColor | ( |  | ) |
| virtual

Set/Get the diffuse surface color.

For PBR Interpolation, DiffuseColor is used as the base color

## ◆ GetDiffuseColor() [2/3]

virtual void vtkProperty::GetDiffuseColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the diffuse surface color.

For PBR Interpolation, DiffuseColor is used as the base color

## ◆ GetDiffuseColor() [3/3]

virtual void vtkProperty::GetDiffuseColor | ( | double | [3] | ) |
| virtual

Set/Get the diffuse surface color.

For PBR Interpolation, DiffuseColor is used as the base color

## ◆ SetSpecularColor() [1/2]

virtual void vtkProperty::SetSpecularColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the specular surface color.

## ◆ SetSpecularColor() [2/2]

virtual void vtkProperty::SetSpecularColor | ( | double | [3] | ) |
| virtual

Set/Get the specular surface color.

## ◆ GetSpecularColor() [1/3]

virtual double* vtkProperty::GetSpecularColor | ( |  | ) |
| virtual

Set/Get the specular surface color.

## ◆ GetSpecularColor() [2/3]

virtual void vtkProperty::GetSpecularColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the specular surface color.

## ◆ GetSpecularColor() [3/3]

virtual void vtkProperty::GetSpecularColor | ( | double | [3] | ) |
| virtual

Set/Get the specular surface color.

## ◆ GetEdgeVisibility()

virtual vtkTypeBool vtkProperty::GetEdgeVisibility | ( |  | ) |
| virtual

Turn on/off the visibility of edges.

On some renderers it is possible to render the edges of geometric primitives separately from the interior.

## ◆ SetEdgeVisibility()

virtual void vtkProperty::SetEdgeVisibility | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the visibility of edges.

On some renderers it is possible to render the edges of geometric primitives separately from the interior.

## ◆ EdgeVisibilityOn()

virtual void vtkProperty::EdgeVisibilityOn | ( |  | ) |
| virtual

Turn on/off the visibility of edges.

On some renderers it is possible to render the edges of geometric primitives separately from the interior.

## ◆ EdgeVisibilityOff()

virtual void vtkProperty::EdgeVisibilityOff | ( |  | ) |
| virtual

Turn on/off the visibility of edges.

On some renderers it is possible to render the edges of geometric primitives separately from the interior.

## ◆ SetEdgeColor() [1/2]

virtual void vtkProperty::SetEdgeColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of primitive edges (if edge visibility is enabled).

## ◆ SetEdgeColor() [2/2]

virtual void vtkProperty::SetEdgeColor | ( | double | [3] | ) |
| virtual

Set/Get the color of primitive edges (if edge visibility is enabled).

## ◆ GetEdgeColor() [1/3]

virtual double* vtkProperty::GetEdgeColor | ( |  | ) |
| virtual

Set/Get the color of primitive edges (if edge visibility is enabled).

## ◆ GetEdgeColor() [2/3]

virtual void vtkProperty::GetEdgeColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the color of primitive edges (if edge visibility is enabled).

## ◆ GetEdgeColor() [3/3]

virtual void vtkProperty::GetEdgeColor | ( | double | [3] | ) |
| virtual

Set/Get the color of primitive edges (if edge visibility is enabled).

## ◆ GetVertexVisibility()

virtual vtkTypeBool vtkProperty::GetVertexVisibility | ( |  | ) |
| virtual

Turn on/off the visibility of vertices.

On some renderers it is possible to render the vertices of geometric primitives separately from the interior.

## ◆ SetVertexVisibility()

virtual void vtkProperty::SetVertexVisibility | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off the visibility of vertices.

On some renderers it is possible to render the vertices of geometric primitives separately from the interior.

## ◆ VertexVisibilityOn()

virtual void vtkProperty::VertexVisibilityOn | ( |  | ) |
| virtual

Turn on/off the visibility of vertices.

On some renderers it is possible to render the vertices of geometric primitives separately from the interior.

## ◆ VertexVisibilityOff()

virtual void vtkProperty::VertexVisibilityOff | ( |  | ) |
| virtual

Turn on/off the visibility of vertices.

On some renderers it is possible to render the vertices of geometric primitives separately from the interior.

## ◆ SetVertexColor() [1/2]

virtual void vtkProperty::SetVertexColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the color of primitive vertices (if vertex visibility is enabled).

## ◆ SetVertexColor() [2/2]

virtual void vtkProperty::SetVertexColor | ( | double | [3] | ) |
| virtual

Set/Get the color of primitive vertices (if vertex visibility is enabled).

## ◆ GetVertexColor() [1/3]

virtual double* vtkProperty::GetVertexColor | ( |  | ) |
| virtual

Set/Get the color of primitive vertices (if vertex visibility is enabled).

## ◆ GetVertexColor() [2/3]

virtual void vtkProperty::GetVertexColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the color of primitive vertices (if vertex visibility is enabled).

## ◆ GetVertexColor() [3/3]

virtual void vtkProperty::GetVertexColor | ( | double | [3] | ) |
| virtual

Set/Get the color of primitive vertices (if vertex visibility is enabled).

## ◆ SetSelectionColor() [1/2]

virtual void vtkProperty::SetSelectionColor | ( | double | ,
|  | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the RGBA color of selection primitives (if a selection is active on the mapper).

Default is red and opaque.

## ◆ SetSelectionColor() [2/2]

virtual void vtkProperty::SetSelectionColor | ( | double | [4] | ) |
| virtual

Set/Get the RGBA color of selection primitives (if a selection is active on the mapper).

Default is red and opaque.

## ◆ GetSelectionColor() [1/3]

virtual double* vtkProperty::GetSelectionColor | ( |  | ) |
| virtual

Set/Get the RGBA color of selection primitives (if a selection is active on the mapper).

Default is red and opaque.

## ◆ GetSelectionColor() [2/3]

virtual void vtkProperty::GetSelectionColor | ( | double & | ,
|  | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the RGBA color of selection primitives (if a selection is active on the mapper).

Default is red and opaque.

## ◆ GetSelectionColor() [3/3]

virtual void vtkProperty::GetSelectionColor | ( | double | [4] | ) |
| virtual

Set/Get the RGBA color of selection primitives (if a selection is active on the mapper).

Default is red and opaque.

## ◆ SetSelectionLineWidth()

virtual void vtkProperty::SetSelectionLineWidth | ( | float |  | ) |
| virtual

Set/Get the selection line width.

Default is 2.

## ◆ GetSelectionLineWidth()

virtual float vtkProperty::GetSelectionLineWidth | ( |  | ) |
| virtual

Set/Get the selection line width.

Default is 2.

## ◆ SetSelectionPointSize()

virtual void vtkProperty::SetSelectionPointSize | ( | float |  | ) |
| virtual

Set/Get the selection point size.

Default is 2.

## ◆ GetSelectionPointSize()

virtual float vtkProperty::GetSelectionPointSize | ( |  | ) |
| virtual

Set/Get the selection point size.

Default is 2.

## ◆ SetLineWidth()

virtual void vtkProperty::SetLineWidth | ( | float |  | ) |
| virtual

Set/Get the width of a Line.

The width is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

## ◆ GetLineWidth()

virtual float vtkProperty::GetLineWidth | ( |  | ) |
| virtual

Set/Get the width of a Line.

The width is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

## ◆ SetLineStipplePattern()

virtual void vtkProperty::SetLineStipplePattern | ( | int |  | ) |
| virtual

Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off).

This is only implemented for OpenGL, not OpenGL2. The default is 0xFFFF.

## ◆ GetLineStipplePattern()

virtual int vtkProperty::GetLineStipplePattern | ( |  | ) |
| virtual

Set/Get the stippling pattern of a Line, as a 16-bit binary pattern (1 = pixel on, 0 = pixel off).

This is only implemented for OpenGL, not OpenGL2. The default is 0xFFFF.

## ◆ SetLineStippleRepeatFactor()

virtual void vtkProperty::SetLineStippleRepeatFactor | ( | int |  | ) |
| virtual

Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated.

This is only implemented for OpenGL, not OpenGL2. The default is 1.

## ◆ GetLineStippleRepeatFactor()

virtual int vtkProperty::GetLineStippleRepeatFactor | ( |  | ) |
| virtual

Set/Get the stippling repeat factor of a Line, which specifies how many times each bit in the pattern is to be repeated.

This is only implemented for OpenGL, not OpenGL2. The default is 1.

## ◆ SetPointSize()

virtual void vtkProperty::SetPointSize | ( | float |  | ) |
| virtual

Set/Get the diameter of a point.

The size is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

## ◆ GetPointSize()

virtual float vtkProperty::GetPointSize | ( |  | ) |
| virtual

Set/Get the diameter of a point.

The size is expressed in screen units. This is only implemented for OpenGL. The default is 1.0.

## ◆ GetBackfaceCulling()

virtual vtkTypeBool vtkProperty::GetBackfaceCulling | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If backface culling is on, polygons facing away from camera are not drawn.

## ◆ SetBackfaceCulling()

virtual void vtkProperty::SetBackfaceCulling | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If backface culling is on, polygons facing away from camera are not drawn.

## ◆ BackfaceCullingOn()

virtual void vtkProperty::BackfaceCullingOn | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If backface culling is on, polygons facing away from camera are not drawn.

## ◆ BackfaceCullingOff()

virtual void vtkProperty::BackfaceCullingOff | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If backface culling is on, polygons facing away from camera are not drawn.

## ◆ GetFrontfaceCulling()

virtual vtkTypeBool vtkProperty::GetFrontfaceCulling | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If frontface culling is on, polygons facing towards camera are not drawn.

## ◆ SetFrontfaceCulling()

virtual void vtkProperty::SetFrontfaceCulling | ( | vtkTypeBool |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If frontface culling is on, polygons facing towards camera are not drawn.

## ◆ FrontfaceCullingOn()

virtual void vtkProperty::FrontfaceCullingOn | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If frontface culling is on, polygons facing towards camera are not drawn.

## ◆ FrontfaceCullingOff()

virtual void vtkProperty::FrontfaceCullingOff | ( |  | ) |
| virtual

Turn on/off fast culling of polygons based on orientation of normal with respect to camera.

If frontface culling is on, polygons facing towards camera are not drawn.

## ◆ SetMaterialName()

virtual void vtkProperty::SetMaterialName | ( | const char * |  | ) |
| virtual

Returns the name of the material currently loaded, if any.

## ◆ GetMaterialName()

virtual char* vtkProperty::GetMaterialName | ( |  | ) |
| virtual

Returns the name of the material currently loaded, if any.

## ◆ SetShading()

virtual void vtkProperty::SetShading | ( | vtkTypeBool |  | ) |
| virtual

Enable/Disable shading.

When shading is enabled, the Material must be set.

## ◆ GetShading()

virtual vtkTypeBool vtkProperty::GetShading | ( |  | ) |
| virtual

Enable/Disable shading.

When shading is enabled, the Material must be set.

## ◆ ShadingOn()

virtual void vtkProperty::ShadingOn | ( |  | ) |
| virtual

Enable/Disable shading.

When shading is enabled, the Material must be set.

## ◆ ShadingOff()

virtual void vtkProperty::ShadingOff | ( |  | ) |
| virtual

Enable/Disable shading.

When shading is enabled, the Material must be set.

## ◆ AddShaderVariable() [1/12]

virtual void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | numVars,
|  | int * | x
| ) |  |
| virtual

Provide values to initialize shader variables.

Useful to initialize shader variables that change over time (animation, GUI widgets inputs, etc. )

- `name` - hardware name of the uniform variable
- `numVars` - number of variables being set
- `x` - values

## ◆ AddShaderVariable() [2/12]

virtual void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | numVars,
|  | float * | x
| ) |  |
| virtual

Provide values to initialize shader variables.

Useful to initialize shader variables that change over time (animation, GUI widgets inputs, etc. )

- `name` - hardware name of the uniform variable
- `numVars` - number of variables being set
- `x` - values

## ◆ AddShaderVariable() [3/12]

virtual void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | numVars,
|  | double * | x
| ) |  |
| virtual

Provide values to initialize shader variables.

Useful to initialize shader variables that change over time (animation, GUI widgets inputs, etc. )

- `name` - hardware name of the uniform variable
- `numVars` - number of variables being set
- `x` - values

## ◆ AddShaderVariable() [4/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | v
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 576 of file vtkProperty.h.

## ◆ AddShaderVariable() [5/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | float | v
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 577 of file vtkProperty.h.

## ◆ AddShaderVariable() [6/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | double | v
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 578 of file vtkProperty.h.

## ◆ AddShaderVariable() [7/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | v1,
|  | int | v2
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 579 of file vtkProperty.h.

## ◆ AddShaderVariable() [8/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | float | v1,
|  | float | v2
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 584 of file vtkProperty.h.

## ◆ AddShaderVariable() [9/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | double | v1,
|  | double | v2
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 589 of file vtkProperty.h.

## ◆ AddShaderVariable() [10/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | int | v1,
|  | int | v2,
|  | int | v3
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 594 of file vtkProperty.h.

## ◆ AddShaderVariable() [11/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | float | v1,
|  | float | v2,
|  | float | v3
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 599 of file vtkProperty.h.

## ◆ AddShaderVariable() [12/12]

void vtkProperty::AddShaderVariable | ( | const char * | name,
|  | double | v1,
|  | double | v2,
|  | double | v3
| ) |  |
| inline

Methods to provide to add shader variables from wrappers.

Definition at line 604 of file vtkProperty.h.

## ◆ SetShowTexturesOnBackface()

virtual void vtkProperty::SetShowTexturesOnBackface | ( | bool |  | ) |
| virtual

Show texture maps when the geometry is backfacing.

Texture maps are always shown when frontfacing. By default this is true.

## ◆ GetShowTexturesOnBackface()

virtual bool vtkProperty::GetShowTexturesOnBackface | ( |  | ) |
| virtual

Show texture maps when the geometry is backfacing.

Texture maps are always shown when frontfacing. By default this is true.

## ◆ ShowTexturesOnBackfaceOn()

virtual void vtkProperty::ShowTexturesOnBackfaceOn | ( |  | ) |
| virtual

Show texture maps when the geometry is backfacing.

Texture maps are always shown when frontfacing. By default this is true.

## ◆ ShowTexturesOnBackfaceOff()

virtual void vtkProperty::ShowTexturesOnBackfaceOff | ( |  | ) |
| virtual

Show texture maps when the geometry is backfacing.

Texture maps are always shown when frontfacing. By default this is true.

## ◆ SetTexture()

void vtkProperty::SetTexture | ( | const char * | name,
|  | vtkTexture * | texture
| ) |  |

Set/Get the texture object to control rendering texture maps.

This will be a vtkTexture object. A property does not need to have an associated texture map and multiple properties can share one texture. Textures must be assigned unique names. Note that for texture blending the textures will be rendering is alphabetical order and after any texture defined in the actor. There exists 6 special textures with reserved names: "albedoTex", "materialTex", "normalTex", "emissiveTex", "anisotropyTex" and "coatNormalTex". While these textures can be added with the regular SetTexture method, it is preferred to use the methods SetBaseColorTexture, SetORMTexture, SetNormalTexture, SetEmissiveTexture, SetAnisotropyTexture and SetCoatNormalTex respectively.

## ◆ GetTexture()

vtkTexture* vtkProperty::GetTexture | ( | const char * | name | ) |

Set/Get the texture object to control rendering texture maps.

This will be a vtkTexture object. A property does not need to have an associated texture map and multiple properties can share one texture. Textures must be assigned unique names. Note that for texture blending the textures will be rendering is alphabetical order and after any texture defined in the actor. There exists 6 special textures with reserved names: "albedoTex", "materialTex", "normalTex", "emissiveTex", "anisotropyTex" and "coatNormalTex". While these textures can be added with the regular SetTexture method, it is preferred to use the methods SetBaseColorTexture, SetORMTexture, SetNormalTexture, SetEmissiveTexture, SetAnisotropyTexture and SetCoatNormalTex respectively.

## ◆ SetBaseColorTexture()

void vtkProperty::SetBaseColorTexture | ( | vtkTexture * | texture | ) |
| inline

Set the base color texture.

Also called albedo, this texture is only used while rendering with PBR interpolation. This is the color of the object. This texture must be in sRGB color space.

See also
  SetInterpolationToPBR vtkTexture::UseSRGBColorSpaceOn

Definition at line 645 of file vtkProperty.h.

## ◆ SetORMTexture()

void vtkProperty::SetORMTexture | ( | vtkTexture * | texture | ) |
| inline

Set the ORM texture.

This texture contains three RGB independent components corresponding to the Occlusion value, Roughness value and Metallic value respectively. Each texture value is scaled by the Occlusion strength, roughness coefficient and metallic coefficient. This texture must be in linear color space. This is only used by the PBR shading model.

See also
  SetInterpolationToPBR SetOcclusionStrength SetMetallic SetRoughness

Definition at line 656 of file vtkProperty.h.

## ◆ SetAnisotropyTexture()

void vtkProperty::SetAnisotropyTexture | ( | vtkTexture * | texture | ) |
| inline

Set the anisotropy texture.

This texture contains two independent components corresponding to the anisotropy value and anisotropy rotation. The last component (blue channel) is discarded. The anisotropy value is scaled by the anisotropy coefficient of the material. The anisotropy rotation rotates the direction of the anisotropy (ie. the tangent) around the normal and is not scaled by the anisotropy rotation coefficient. This texture must be in linear color space. This is only used by the PBR shading model.

See also
  SetInterpolationToPBR SetAnisotropy

Definition at line 668 of file vtkProperty.h.

## ◆ SetNormalTexture()

void vtkProperty::SetNormalTexture | ( | vtkTexture * | texture | ) |
| inline

Set the normal texture.

This texture is required for normal mapping. It is valid for both PBR and Phong interpolation. The normal mapping is enabled if this texture is present and both normals and tangents are presents in the vtkPolyData. This texture must be in linear color space.

See also
  vtkPolyDataTangents SetNormalScale

Definition at line 678 of file vtkProperty.h.

## ◆ SetEmissiveTexture()

void vtkProperty::SetEmissiveTexture | ( | vtkTexture * | texture | ) |
| inline

Set the emissive texture.

When present, this RGB texture provides location and color to the shader where the vtkPolyData should emit light. Emitted light is scaled by EmissiveFactor. This is only supported by PBR interpolation model. This texture must be in sRGB color space.

See also
  SetInterpolationToPBR SetEmissiveFactor vtkTexture::UseSRGBColorSpaceOn

Definition at line 687 of file vtkProperty.h.

## ◆ SetCoatNormalTexture()

void vtkProperty::SetCoatNormalTexture | ( | vtkTexture * | texture | ) |
| inline

Set the coat normal texture.

This texture is required for coat normal mapping. It is valid only for PBR interpolation. The coat normal mapping is enabled if this texture is present and both normals and tangents are presents in the vtkPolyData. This texture must be in linear color space.

See also
  vtkPolyDataTangents SetCoatNormalScale

Definition at line 697 of file vtkProperty.h.

## ◆ RemoveTexture()

void vtkProperty::RemoveTexture | ( | const char * | name | ) |

Remove a texture from the collection.

## ◆ RemoveAllTextures()

void vtkProperty::RemoveAllTextures | ( |  | ) |

Remove all the textures.

## ◆ GetNumberOfTextures()

int vtkProperty::GetNumberOfTextures | ( |  | ) |

Returns the number of textures in this property.

## ◆ GetAllTextures()

std::map<std::string, vtkTexture*>& vtkProperty::GetAllTextures | ( |  | ) |
| inline

Returns all the textures in this property and their names.

Definition at line 717 of file vtkProperty.h.

## ◆ ReleaseGraphicsResources()

virtual void vtkProperty::ReleaseGraphicsResources | ( | vtkWindow * | win | ) |
| virtual

Release any graphics resources that are being consumed by this property.

The parameter window could be used to determine which graphic resources to release.

Reimplemented in vtkWebGPUProperty, and vtkOpenGLProperty.

## ◆ GetInformation()

virtual vtkInformation* vtkProperty::GetInformation | ( |  | ) |
| virtual

Set/Get the information object associated with the Property.

## ◆ SetInformation()

virtual void vtkProperty::SetInformation | ( | vtkInformation * |  | ) |
| virtual

Set/Get the information object associated with the Property.

## ◆ ComputeReflectanceFromIOR()

static double vtkProperty::ComputeReflectanceFromIOR | ( | double | IORTo,
|  | double | IORFrom
| ) |  |
| static

For PBR, calculate the reflectance from the refractive index of ingoing and outgoing interfaces.

## ◆ ComputeIORFromReflectance()

static double vtkProperty::ComputeIORFromReflectance | ( | double | reflectance,
|  | double | ior
| ) |  |
| static

For PBR, calculate the refractive index from the reflectance of the interface and the refractive index of one of both medium.

## ◆ ComputeReflectanceOfBaseLayer()

double vtkProperty::ComputeReflectanceOfBaseLayer | ( |  | ) |

For PBR, calculate the reflectance of the base layer depending on the presence of a coat layer.

If there is no coat layer, the reflectance is the one at the interface environment - base layer. If a coat layer is present, the reflectance is the one at the interface between the base and the coat layer.

## ◆ ComputeCompositeColor()

static void vtkProperty::ComputeCompositeColor | ( | double | result[3],
|  | double | ambient,
|  | const double | ambient_color[3],
|  | double | diffuse,
|  | const double | diffuse_color[3],
|  | double | specular,
|  | const double | specular_color[3]
| ) |  |
| staticprotected

Computes composite color.

Used by GetColor().

## Member Data Documentation

## ◆ Color

double vtkProperty::Color[3]
| protected

Definition at line 770 of file vtkProperty.h.

## ◆ AmbientColor

double vtkProperty::AmbientColor[3]
| protected

Definition at line 771 of file vtkProperty.h.

## ◆ DiffuseColor

double vtkProperty::DiffuseColor[3]
| protected

Definition at line 772 of file vtkProperty.h.

## ◆ SpecularColor

double vtkProperty::SpecularColor[3]
| protected

Definition at line 773 of file vtkProperty.h.

## ◆ EdgeColor

double vtkProperty::EdgeColor[3]
| protected

Definition at line 774 of file vtkProperty.h.

## ◆ VertexColor

double vtkProperty::VertexColor[3]
| protected

Definition at line 775 of file vtkProperty.h.

## ◆ SelectionColor

double vtkProperty::SelectionColor[4] = { 1.0, 0.0, 0.0, 1.0 }
| protected

Definition at line 776 of file vtkProperty.h.

## ◆ Ambient

double vtkProperty::Ambient
| protected

Definition at line 777 of file vtkProperty.h.

## ◆ Diffuse

double vtkProperty::Diffuse
| protected

Definition at line 778 of file vtkProperty.h.

## ◆ Metallic

double vtkProperty::Metallic
| protected

Definition at line 779 of file vtkProperty.h.

## ◆ Roughness

double vtkProperty::Roughness
| protected

Definition at line 780 of file vtkProperty.h.

## ◆ Anisotropy

double vtkProperty::Anisotropy
| protected

Definition at line 781 of file vtkProperty.h.

## ◆ AnisotropyRotation

double vtkProperty::AnisotropyRotation
| protected

Definition at line 782 of file vtkProperty.h.

## ◆ BaseIOR

double vtkProperty::BaseIOR
| protected

Definition at line 783 of file vtkProperty.h.

## ◆ CoatIOR

double vtkProperty::CoatIOR
| protected

Definition at line 784 of file vtkProperty.h.

## ◆ CoatColor

double vtkProperty::CoatColor[3]
| protected

Definition at line 785 of file vtkProperty.h.

## ◆ CoatRoughness

double vtkProperty::CoatRoughness
| protected

Definition at line 786 of file vtkProperty.h.

## ◆ CoatStrength

double vtkProperty::CoatStrength
| protected

Definition at line 787 of file vtkProperty.h.

## ◆ CoatNormalScale

double vtkProperty::CoatNormalScale
| protected

Definition at line 788 of file vtkProperty.h.

## ◆ NormalScale

double vtkProperty::NormalScale
| protected

Definition at line 789 of file vtkProperty.h.

## ◆ OcclusionStrength

double vtkProperty::OcclusionStrength
| protected

Definition at line 790 of file vtkProperty.h.

## ◆ EmissiveFactor

double vtkProperty::EmissiveFactor[3]
| protected

Definition at line 791 of file vtkProperty.h.

## ◆ Specular

double vtkProperty::Specular
| protected

Definition at line 792 of file vtkProperty.h.

## ◆ SpecularPower

double vtkProperty::SpecularPower
| protected

Definition at line 793 of file vtkProperty.h.

## ◆ Opacity

double vtkProperty::Opacity
| protected

Definition at line 794 of file vtkProperty.h.

## ◆ EdgeOpacity

double vtkProperty::EdgeOpacity = 1.0
| protected

Definition at line 795 of file vtkProperty.h.

## ◆ EdgeTint

double vtkProperty::EdgeTint[3]
| protected

Definition at line 796 of file vtkProperty.h.

## ◆ PointSize

float vtkProperty::PointSize
| protected

Definition at line 797 of file vtkProperty.h.

## ◆ LineWidth

float vtkProperty::LineWidth
| protected

Definition at line 798 of file vtkProperty.h.

## ◆ SelectionPointSize

float vtkProperty::SelectionPointSize = 2.f
| protected

Definition at line 799 of file vtkProperty.h.

## ◆ SelectionLineWidth

float vtkProperty::SelectionLineWidth = 2.f
| protected

Definition at line 800 of file vtkProperty.h.

## ◆ LineStipplePattern

int vtkProperty::LineStipplePattern
| protected

Definition at line 801 of file vtkProperty.h.

## ◆ LineStippleRepeatFactor

int vtkProperty::LineStippleRepeatFactor
| protected

Definition at line 802 of file vtkProperty.h.

## ◆ Interpolation

int vtkProperty::Interpolation
| protected

Definition at line 803 of file vtkProperty.h.

## ◆ Representation

int vtkProperty::Representation
| protected

Definition at line 804 of file vtkProperty.h.

## ◆ EdgeVisibility

vtkTypeBool vtkProperty::EdgeVisibility
| protected

Definition at line 805 of file vtkProperty.h.

## ◆ VertexVisibility

vtkTypeBool vtkProperty::VertexVisibility
| protected

Definition at line 806 of file vtkProperty.h.

## ◆ BackfaceCulling

vtkTypeBool vtkProperty::BackfaceCulling
| protected

Definition at line 807 of file vtkProperty.h.

## ◆ FrontfaceCulling

vtkTypeBool vtkProperty::FrontfaceCulling
| protected

Definition at line 808 of file vtkProperty.h.

## ◆ Lighting

bool vtkProperty::Lighting
| protected

Definition at line 809 of file vtkProperty.h.

## ◆ RenderPointsAsSpheres

bool vtkProperty::RenderPointsAsSpheres
| protected

Definition at line 810 of file vtkProperty.h.

## ◆ RenderLinesAsTubes

bool vtkProperty::RenderLinesAsTubes
| protected

Definition at line 811 of file vtkProperty.h.

## ◆ ShowTexturesOnBackface

bool vtkProperty::ShowTexturesOnBackface
| protected

Definition at line 812 of file vtkProperty.h.

## ◆ Shading

vtkTypeBool vtkProperty::Shading
| protected

Definition at line 814 of file vtkProperty.h.

## ◆ MaterialName

char* vtkProperty::MaterialName
| protected

Definition at line 816 of file vtkProperty.h.

## ◆ Textures

MapOfTextures vtkProperty::Textures
| protected

Definition at line 819 of file vtkProperty.h.

## ◆ Information

vtkInformation* vtkProperty::Information
| protected

Definition at line 822 of file vtkProperty.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkProperty.h